/*
 * MyParam.java
 */

package delegate;

import java.io.Serializable;
import original.Param;

public class MyParam implements Serializable
{
    private Param param;

    public MyParam() {}

    public MyParam(Param param) {
        this.param = param;
    }

    public MyParam(Object value) {
        this(new Data(value));
    }

    public Param getParam() {
        return param;
    }

    public void setParam(Param param) {
        this.param = param;
    }

    public Object getValue() {
        return (param == null) ? null : param.getValue();
    }

    public void setValue(Object value) {
        if (param == null) {
            param = new Param();
        }
        param.setValue(value);
    }

    public String toString() {
        return "MyParam {param=" + param + "}";
    }

    public static class Data extends Param {
        public Data(Object value) {
            super(value);
        }
    }
}
