/*
 * MyProcessorAdapter.java
 */

package delegate;

import original.*;

public class MyProcessorAdapter extends AbstractProcessor
{
    private MyProcessor adaptee;

    protected MyProcessorAdapter(MyProcessor adaptee) {
        this.adaptee = adaptee;
    }

    public static MyProcessorAdapter create(String name) {
        MyProcessorFactory factory = MyProcessorFactory.getInstance();
        MyProcessor processor = factory.getMyProcessor(name);
        return new MyProcessorAdapter(processor);
    }

    // Ǝ̈A߂lAOgpB
    public Result process(Param param) throws AppException {
        try {
            MyResult result = adaptee.process(new MyParam(param));
            return (result == null) ? null : result.getResult();
        } catch (MyAppException e) {
            throw e.getAppException();
        }
    }

    // Ǝ̈gpB߂l͈ʓIȌ^B
    public Object process2(Param param) {
        return adaptee.process2(new MyParam(param));
    }

    // Ǝ̖߂lgpB͈ʓIȌ^B
    public Result process3(Object param) {
        MyResult result = adaptee.process3(param);
        return (result == null) ? null : result.getResult();
    }

    // A߂l͈ʓIȌ^B
    public Object process4(Object param) {
        return adaptee.process4(param);
    }
}
