/*
 * MyProcessorFactory.java
 */

package delegate;

import java.util.Properties;
import original.SystemException;
import util.LoaderUtils;

public class MyProcessorFactory
{
    private static MyProcessorFactory instance = new MyProcessorFactory();

    private Properties props;

    protected MyProcessorFactory() {
        props = LoaderUtils.loadProperties("processor.properties");
    }

    public static MyProcessorFactory getInstance() {
        return instance;
    }

    public MyProcessor getMyProcessor(String name) {
        String key = "myProcessor.class." + name;
        String className = props.getProperty(key);
        if (className == null || className.length() == 0) {
            throw new SystemException("MyProcessor not found: " + name);
        }
        try {
            Class clazz = LoaderUtils.loadClass(className);
            return (MyProcessor)clazz.newInstance();
        } catch (Exception e) {
            throw new SystemException(e);
        }
    }
}
