/*
 * MyResult.java
 */

package delegate;

import java.io.Serializable;
import original.Result;

public class MyResult implements Serializable
{
    private Result result;

    public MyResult() {}

    public MyResult(Result result) {
        this.result = result;
    }

    public MyResult(Object value) {
        this(new Result(value));
    }

    public Result getResult() {
        return result;
    }

    public void setResult(Result result) {
        this.result = result;
    }

    public Object getValue() {
        return (result == null) ? null : result.getValue();
    }

    public void setValue(Object value) {
        if (result == null) {
            result = new Result();
        }
        result.setValue(value);
    }

    public String toString() {
        return "MyResult {result=" + result + "}";
    }
}
