/*
 * LoaderUtils.java
 */

package util;

import java.io.*;
import java.util.Properties;

public class LoaderUtils
{
    protected LoaderUtils() {}

    public static Properties loadProperties(String configName) {
        Properties props = new Properties();
        InputStream in = null;
        try {
            ClassLoader loader = getContextClassLoader();
            in = loader.getResourceAsStream(configName);
            props.load(in);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (in != null) {
                try { in.close(); } catch (IOException e) {}
            }
        }
        return props;
    }

    public static Class loadClass(String className)
            throws ClassNotFoundException {
        ClassLoader loader = getContextClassLoader();
        return Class.forName(className, true, loader);
    }

    public static ClassLoader getContextClassLoader() {
        return Thread.currentThread().getContextClassLoader();
    }
}
